
gurmukhi_to_devanagari = {
  'ਇ': 'इ',
  'ਉ': 'उ',
  'ਊ': 'ऊ',
  'ਈ': 'ई',
  'ਏ': 'ए',
  'ਆ': 'आ',
  'ਐ': 'ऐ',
  'ਔ': 'औ',
  'ੜ੍ਹ': 'ढ़',
  '੍': '्',
  'ੰ': 'ं',
  'ਿ': 'ि',
  'ੀ': 'ी',
  'ੁ': 'ु',
  'ੂ': 'ू',
  'ੇ': 'े',
  'ੈ': 'ै',
  'ਂ': 'ं',
  'ੋ': 'ो',
  'ੌ': 'ौ',
  'ਾ': 'ा',
  'ੵ': '्य',
  'ੑ': '',
  'ਃ': 'ः',
  'ੱਖ': 'क्ख',
  'ੱਛ': 'च्छ',
  'ੱਧ': 'द्ध',
  'ੱ': '',
  'ਨ਼': 'ऩ',
  'ਰ਼': 'ऱ',
  'ਕ਼': 'क़',
  'ਯ਼': 'य़',
  'ਙ': 'ङ',
  'ੳ': 'उ',
  'ਅ': 'अ',
  'ਬ': 'ब',
  'ਭ': 'भ',
  'ਚ': 'च',
  'ਛ': 'छ',
  'ਦ': 'द',
  'ਧ': 'ध',
  'ੲ': 'इ',
  'ਓ': 'ओ',
  'ਡ': 'ड',
  'ਢ': 'ढ',
  'ਗ': 'ग',
  'ਘ': 'घ',
  'ਹ': 'ह',
  'ਜ': 'ज',
  'ਝ': 'झ',
  'ਕ': 'क',
  'ਖ': 'ख',
  'ਲ': 'ल',
  'ਲ਼': 'ळ',
  'ਮ': 'म',
  'ਨ': 'न',
  'ਪ': 'प',
  'ਫ': 'फ',
  'ਤ': 'त',
  'ਥ': 'थ',
  'ਰ': 'र',
  'ਸ': 'स',
  'ਸ਼': 'श',
  'ਟ': 'ट',
  'ਠ': 'ठ',
  'ਵ': 'व',
  'ੜ': 'ड़',
  'ਣ': 'ण',
  'ਯ': 'य',
  'ਜ਼': 'ज़',
  'ਗ਼': 'ग़',
  'ਖ਼': 'क़',
  'ਫ਼': 'फ़',
  'ਞ': 'ञ',
  '੧': '१',
  '੨': '२',
  '੩': '३',
  '੪': '४',
  '੫': '५',
  '੬': '६',
  '੭': '७',
  '੮': '८',
  '੯': '९',
  '੦': '०',
  '਼': '़',
}

gurmukhi_to_shahmukhi = {
  'ਇਆ': 'يا',
  'ਿਓ': 'يو',
  'ੰਪ': 'مپ',
  'ੰਨ': 'نّ',
  'ਇ': 'ِا',
  'ਉ': 'اُ',
  'ਊ': 'اُو',
  'ਈ': 'ای',
  'ਏ': 'اے',
  'ਆ': 'آ',
  'ਐ': 'اَے',
  'ਔ': 'اَو',
  'ਆਂ': 'آں',
  'ੴ': 'اک اونکار',
  '੍ਟ': 'ٹ',
  '੍ਨ': 'ن',
  '੍ਯ': 'ے',
  '੍ਚ': 'چ',
  '੍ਤ': 'ت',
  'ੰ': 'ں',
  '੍ਹ': 'ھ',
  'ਿ': 'ِ',
  'ੀ': 'ی',
  'ੁ': 'ُ',
  'ੂ': 'ُو',
  'ੇ': 'ے',
  'ੈ': 'َے',
  'ਂ': 'ں',
  'ੋ': 'و',
  'ੌ': 'َو',
  '੍ਰ': 'ر',
  'ਾ': 'ا',
  'ੵ': 'ے',
  'ੑ': 'ھ',
  'ੱ': 'ّ',
  '੍ਵ': 'و',
  'ਃ': ':',
  'ਙ': 'نگ',
  'ੳ': 'ا',
  'ਅ': 'ا',
  'ਬ': 'ب',
  'ਭ': 'بھ',
  'ਚ': 'چ',
  'ਛ': 'چھ',
  'ਦ': 'د',
  'ਧ': 'دھ',
  'ੲ': 'ا',
  'ਓ': 'اَو',
  'ਡ': 'ڈ',
  'ਢ': 'ڈھ',
  'ਗ': 'گ',
  'ਘ': 'گھ',
  'ਹ': 'ه',
  'ਜ': 'ج',
  'ਝ': 'جھ',
  'ਕ': 'ک',
  'ਖ': 'کھ',
  'ਲ': 'ل',
  'ਲ਼': 'ل',
  'ਮ': 'م',
  'ਨ': 'ن',
  'ਪ': 'پ',
  'ਫ': 'پھ',
  'ਤ': 'ت',
  'ਥ': 'تھ',
  'ਰ': 'ر',
  'ਸ': 'س',
  'ਸ਼': 'ش',
  'ਟ': 'ٹ',
  'ਠ': 'ٹھ',
  'ਵ': 'و',
  'ੜ': 'ڑ',
  'ਣ': 'ن',
  'ਯ': 'ے',
  'ਜ਼': 'ز',
  'ਗ਼': 'غ',
  'ਖ਼': 'خ',
  'ਫ਼': 'ف',
  'ਞ': 'نج',
  '੧': '۱',
  '੨': '۲',
  '੩': '۳',
  '੪': '۴',
  '੫': '۵',
  '੬': '۶',
  '੭': '۷',
  '੮': '۸',
  '੯': '۹',
  '੦': '۰',
  '।': '۔',
  '॥': '۔۔',
  '਼': '',
}

def gurmukhi_to_devanagari(text):
    """ Convert Gurmukhi text to Devanagari """
    
    # TODO - pre mapping replacement rule - Move Tippi and Bindi after Bihari

    # Convert each Gurmukhi character to Devanagari
    for exp, sub in gurmukhi_to_devanagari.items():
        text = text.replace(exp, sub)
    return text

def devanagari_to_gurmukhi(text):
    # Swap mappings of Gurmukhi and Devanagari
    devanagari_to_gurmukhi = {value: key for key, value in gurmukhi_to_devanagari.items()}

    # TODO - pre mapping replacement rule - opposite rule to the next one

    # Convert each Gurmukhi character to Devanagari
    for exp, sub in gurmukhi_to_devanagari.items():
        text = text.replace(exp, sub)
    return text

def gurmukhi_to_shahmukhi(text):
    # TODO - pre mapping replacement rule - Remove trailing ੁ and ਿ except when on ਹ or on a standalone akhar

    # Convert each Gurmukhi character to Devanagari
    for exp, sub in gurmukhi_to_shahmukhi.items():
        text = text.replace(exp, sub)
    return text

# TODO - shahmukhi_to_gurmukhi

# TODO - gurmukhi_to_roman

# TODO - roman_to_gurmukhi

# TODO - gurmukhi_to_ipa

# TODO - ipa_to_gurmukhi